VERSION 4.00
Begin VB.Form frmDialog 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2280
   ClientLeft      =   4725
   ClientTop       =   1560
   ClientWidth     =   1995
   ControlBox      =   0   'False
   Height          =   2685
   Left            =   4665
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2280
   ScaleWidth      =   1995
   Top             =   1215
   Width           =   2115
   Begin VB.TextBox txtRateValue 
      Height          =   285
      Left            =   630
      MaxLength       =   3
      TabIndex        =   1
      Text            =   " "
      Top             =   1200
      Width           =   500
   End
   Begin VB.CommandButton butIncrRate 
      Caption         =   ">"
      Height          =   255
      Left            =   1130
      TabIndex        =   9
      Top             =   1220
      Width           =   255
   End
   Begin VB.CommandButton butDecrRate 
      Caption         =   "<"
      Height          =   255
      Left            =   380
      TabIndex        =   8
      Top             =   1220
      Width           =   250
   End
   Begin VB.TextBox txtVarValue 
      Height          =   285
      Left            =   630
      MaxLength       =   3
      TabIndex        =   0
      Text            =   " "
      Top             =   360
      Width           =   500
   End
   Begin VB.CommandButton butIncrease 
      Caption         =   ">"
      Height          =   255
      Left            =   1130
      TabIndex        =   5
      Top             =   380
      Width           =   250
   End
   Begin VB.CommandButton butDecrease 
      Caption         =   "<"
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   375
      Width           =   250
   End
   Begin VB.CommandButton butCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   960
      TabIndex        =   3
      Top             =   1680
      Width           =   735
   End
   Begin VB.CommandButton butOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   1680
      Width           =   735
   End
   Begin VB.Label labRateName 
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   960
      Width           =   2175
   End
   Begin VB.Label labVarName 
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "frmDialog"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub butCancel_Click()
'Version date = 97.12.10

txtVarValue.SetFocus
Hide
frmSurprise.butQuit.SetFocus
frmSurprise.CurrentY = Helm_y: frmSurprise.CurrentX = Item_x
frmSurprise.Print "Helm" 'text no longer dimmed
End Sub

Private Sub butDecrease_Click()
'Version date = 96.09.15
txtVarValue.Text = txtVarValue.Text - 1
End Sub

Private Sub butDecrRate_Click()
'Version date = 96.09.15
If txtRateValue.Text > 1 Then
  txtRateValue.Text = txtRateValue.Text / 2
End If
End Sub

Private Sub butIncrease_Click()
'Version date = 96.09.15
txtVarValue.Text = txtVarValue.Text + 1
End Sub

Private Sub butIncrRate_Click()
'Version date = 96.09.15
If txtRateValue.Text < 256 Then
  txtRateValue.Text = txtRateValue.Text * 2
End If
End Sub

Private Sub butOK_Click()
'Version date = 97.12.28

Dim IVar_l As Integer, IRate_l As Integer
Dim Angle_l As Integer, i As Integer

IVar_l = txtVarValue.Text
Select Case WhichDialog
  Case 1
    'wind direction
    If IVar_l < 0 Or IVar_l > 360 Then
      Call frmSurprise.ShowMessage(LTrim(Str(IVar_l)) & " " & Chr$(176) & " is illegal wind direction")
      txtVarValue.SetFocus
      Hide
      frmSurprise.butQuit.SetFocus
      Exit Sub
    End If
    IRate_l = txtRateValue.Text
    If IRate_l < 0 Or IRate_l > 255 Then
      Call frmSurprise.ShowMessage(LTrim(Str(IRate_l)) & " is illegal rate of change")
      txtVarValue.SetFocus
      Hide
      frmSurprise.butQuit.SetFocus
      Exit Sub
    End If
    NewWindDirection = IVar_l
    If NewWindDirection <> WindDirection Then
      If NewWindDirection > WindDirection Then
        Call frmSurprise.ShowMessage("Wind veering to" & Str(NewWindDirection) & " " & Chr$(176) & " at")
      Else
        Call frmSurprise.ShowMessage("Wind backing to" & Str(NewWindDirection) & " " & Chr$(176) & " at")
      End If
      DeltaWindDir = IRate_l / 120
      Call frmSurprise.ShowMessage(LTrim(Str(DeltaWindDir * 120)) & " " & Chr$(176) & "/min")
      booWindDirChange = True
    End If
  Case 2
    'wind speed
    If IVar_l < 0 Or IVar_l > 50 Then
      Call frmSurprise.ShowMessage(LTrim(Str(IVar_l)) & " kts is illegal wind speed")
      txtVarValue.SetFocus
      Hide
      frmSurprise.butQuit.SetFocus
      Exit Sub
    End If
    IRate_l = txtRateValue.Text
    If IRate_l < 1 Or IRate_l > 255 Then
      Call frmSurprise.ShowMessage(LTrim(Str(IRate_l)) & " is illegal rate of change")
      txtVarValue.SetFocus
      Hide
      frmSurprise.butQuit.SetFocus
      Exit Sub
    End If
    NewWindSpeed = IVar_l
    If NewWindSpeed <> WindSpeed Then
      If NewWindSpeed > WindSpeed Then
        Call frmSurprise.ShowMessage("Wind speed incr. to" & Str(NewWindSpeed) & " kt at")
      Else
        Call frmSurprise.ShowMessage("Wind speed decr. to" & Str(NewWindSpeed) & " kt at")
      End If
      DeltaWindSpeed = txtRateValue.Text / 120
      Call frmSurprise.ShowMessage(LTrim(Str(DeltaWindSpeed * 120)) & " kt/min")
      booWindSpeedChange = True
    End If
  Case 3
    'heading to steer
    If IVar_l < 0 Or IVar_l > 360 Then
      Call frmSurprise.ShowMessage(LTrim(Str(IVar_l)) & " " & Chr$(176) & " is illegal heading")
      txtVarValue.SetFocus
      Hide
      frmSurprise.butQuit.SetFocus
      Exit Sub
    End If
    RequiredHeading = IVar_l
    frmSurprise.Line (AutoPilot_x + 0.4, AutoPilot_y + 1.5)-(AutoPilot_x + 5.7, AutoPilot_y + 2.5), BackColor, BF
    If Abs(Int(Heading - IVar_l)) < 2 Then
      HelmInstruction$ = "steering " & IVar_l & " " & Chr$(176)
      Call frmSurprise.ShowMessage("Hold a heading of" & Str(RequiredHeading) & " " & Chr$(176))
    Else
      HelmInstruction$ = "  go to " & IVar_l & " " & Chr$(176)
      Call frmSurprise.ShowMessage("Go to a heading of" & Str(RequiredHeading) & " " & Chr$(176))
    End If
    frmSurprise.CurrentX = AutoPilot_x + 0.4
    frmSurprise.CurrentY = AutoPilot_y + 1.5
    frmSurprise.Print HelmInstruction$
    booHelmsman = True
    frmSurprise.CurrentY = Helm_y: frmSurprise.CurrentX = Item_x
    frmSurprise.ForeColor = QBColor(8): frmSurprise.Print "Helm"
    frmSurprise.ForeColor = QBColor(0)
    Angle_l = RequiredHeading - (WindDirection + 180)
    If Angle_l < -180 Then Angle_l = Angle_l + 360
    If Angle_l > 180 Then Angle_l = Angle_l - 360
    If Abs(Angle_l) > 105 Then
      Call frmSurprise.ShowMessage("Warning: heading of" & Str(RequiredHeading) & " " & Chr$(176) & " may")
      Call frmSurprise.ShowMessage("be too close to wind")
    End If
End Select
txtVarValue.SetFocus
Hide
frmSurprise.butQuit.SetFocus
End Sub

Private Sub txtRateValue_KeyPress(KeyAscii As Integer)
'Version date = 96.10.28

If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
  If KeyAscii = 13 Then
    'enter
    Call butOK_Click
  Else
    If KeyAscii > Asc("9") Then
      Call frmSurprise.ShowMessage("Only numeric input is legal here")
      KeyAscii = 0
    End If
  End If
End If
End Sub

Private Sub txtVarValue_KeyPress(KeyAscii As Integer)
'Version date = 96.10.28

If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
  If KeyAscii = 13 Then
    'enter
    If WhichDialog < 3 Then
      txtRateValue.SetFocus
    Else
      Call butOK_Click
    End If
  Else
    If KeyAscii > Asc("9") Then
      Call frmSurprise.ShowMessage("Only numeric input is legal here")
      KeyAscii = 0
    End If
  End If
End If
End Sub

